MindWrtParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
MindWrtParser Class Reference

the main class to read a MindWrite file More...

`#include <MindWrtParser.hxx>`

Inheritance diagram for MindWrtParser:

## Public Member Functions
| MindWrtParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~MindWrtParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
virtual | ~MWAWTextParser ()
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | sendZone (int i)
| try to send a zone More...
bool | readGraphic (MindWrtParserInternal::LineInfo const &line)
| try to read a graphic More...
bool | readRuler (MindWrtParserInternal::LineInfo &line)
| try to read a ruler More...
bool | readCompressedText (MindWrtParserInternal::LineInfo const &line)
| try to read a compressed text zone More...
bool | readText (MindWrtParserInternal::LineInfo const &line)
| try to read a non compressed text zone More...
void | sendText (std::string const &text, std::vector< MWAWFont > const &fonts, std::vector< int > const &textPos)
| try to send the text More...
void | sendHeaderFooter (bool header)
| try to send the header/footer zone More...
void | sendHeaderFooterFields (bool header)
| try to send the header/footer fields as text (in a textbox) More...
bool | readFonts (MWAWEntry const &entry, std::vector< MWAWFont > &fonts, std::vector< int > &textPos)
| try to read the fonts More...
bool | readPrintInfo (MWAWEntry &entry)
| read the print info zone More...
bool | readLinesInfo (MWAWEntry &entry)
| read the lines information zone More...
bool | readLastZone (MWAWEntry &entry)
| read the last zone ( pos + 7fffffff ) More...
bool | readZone8 (MWAWEntry &entry)
| read the 8th zone ( unknown zone) More...
bool | readHeadingStates (MWAWEntry &entry)
| read the heading state More...
bool | readHeadingFields (MWAWEntry &entry)
| read the heading field zone ( zone 12 ) More...
bool | readHeadingProperties (MWAWEntry &entry)
| read the heading property zone More...
bool | readHeadingCustom (MWAWEntry &entry)
| read the heading custom zone More...
void | setProperty (MWAWParagraph const &para)
| sends a paragraph property to the listener More...
void | newPage (int number)
| adds a new page More...
MWAWEntry | readEntry ()
| read a file entry More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< MindWrtParserInternal::State > | m_state
| the state More...

## Friends
class | MindWrtParserInternal::SubDocument

## Detailed Description

the main class to read a MindWrite file

## Constructor & Destructor Documentation

## ◆ MindWrtParser()

MindWrtParser::MindWrtParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~MindWrtParser()

MindWrtParser::~MindWrtParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MindWrtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void MindWrtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool MindWrtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ init()

void MindWrtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MindWrtParser().

## ◆ newPage()

void MindWrtParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by sendZone().

## ◆ parse()

void MindWrtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readCompressedText()

bool MindWrtParser::readCompressedText | ( | MindWrtParserInternal::LineInfo const & | line | ) |
| protected

try to read a compressed text zone

Referenced by sendZone().

## ◆ readEntry()

MWAWEntry MindWrtParser::readEntry | ( |  | ) |
| protected

read a file entry

Referenced by createZones().

## ◆ readFonts()

bool MindWrtParser::readFonts | ( | MWAWEntry const & | entry,
|  | std::vector< MWAWFont > & | fonts,
|  | std::vector< int > & | textPos
| ) |  |
| protected

try to read the fonts

Referenced by readCompressedText(), and readText().

## ◆ readGraphic()

bool MindWrtParser::readGraphic | ( | MindWrtParserInternal::LineInfo const & | line | ) |
| protected

try to read a graphic

Referenced by sendZone().

## ◆ readHeadingCustom()

bool MindWrtParser::readHeadingCustom | ( | MWAWEntry & | entry | ) |
| protected

read the heading custom zone

Referenced by createZones().

## ◆ readHeadingFields()

bool MindWrtParser::readHeadingFields | ( | MWAWEntry & | entry | ) |
| protected

read the heading field zone ( zone 12 )

Referenced by createZones().

## ◆ readHeadingProperties()

bool MindWrtParser::readHeadingProperties | ( | MWAWEntry & | entry | ) |
| protected

read the heading property zone

Referenced by createZones().

## ◆ readHeadingStates()

bool MindWrtParser::readHeadingStates | ( | MWAWEntry & | entry | ) |
| protected

read the heading state

Referenced by createZones().

## ◆ readLastZone()

bool MindWrtParser::readLastZone | ( | MWAWEntry & | entry | ) |
| protected

read the last zone ( pos + 7fffffff )

Referenced by createZones().

## ◆ readLinesInfo()

bool MindWrtParser::readLinesInfo | ( | MWAWEntry & | entry | ) |
| protected

read the lines information zone

01[45]0

Referenced by createZones().

## ◆ readPrintInfo()

bool MindWrtParser::readPrintInfo | ( | MWAWEntry & | entry | ) |
| protected

read the print info zone

Referenced by createZones().

## ◆ readRuler()

bool MindWrtParser::readRuler | ( | MindWrtParserInternal::LineInfo & | line | ) |
| protected

try to read a ruler

Referenced by readLinesInfo().

## ◆ readText()

bool MindWrtParser::readText | ( | MindWrtParserInternal::LineInfo const & | line | ) |
| protected

try to read a non compressed text zone

Referenced by sendZone().

## ◆ readZone8()

bool MindWrtParser::readZone8 | ( | MWAWEntry & | entry | ) |
| protected

read the 8th zone ( unknown zone)

Referenced by createZones().

## ◆ sendHeaderFooter()

void MindWrtParser::sendHeaderFooter | ( | bool | header | ) |
| protected

try to send the header/footer zone

field are separated from the main text -> we need to use an intermediate frame

Referenced by MindWrtParserInternal::SubDocument::parse().

## ◆ sendHeaderFooterFields()

void MindWrtParser::sendHeaderFooterFields | ( | bool | header | ) |
| protected

try to send the header/footer fields as text (in a textbox)

Referenced by MindWrtParserInternal::SubDocument::parse().

## ◆ sendText()

void MindWrtParser::sendText | ( | std::string const & | text,
|  | std::vector< MWAWFont > const & | fonts,
|  | std::vector< int > const & | textPos
| ) |  |
| protected

try to send the text

Referenced by readCompressedText(), and readText().

## ◆ sendZone()

bool MindWrtParser::sendZone | ( | int | i | ) |
| protected

try to send a zone

Referenced by parse(), and sendHeaderFooter().

## ◆ setProperty()

void MindWrtParser::setProperty | ( | MWAWParagraph const & | para | ) |
| protected

sends a paragraph property to the listener

Referenced by sendZone().

## Friends And Related Function Documentation

## ◆ MindWrtParserInternal::SubDocument

friend class MindWrtParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

shared_ptr<MindWrtParserInternal::State> MindWrtParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), newPage(), parse(), readCompressedText(), readHeadingCustom(), readHeadingFields(), readHeadingProperties(), readLinesInfo(), readZone8(), sendHeaderFooter(), sendHeaderFooterFields(), and sendZone().

The documentation for this class was generated from the following files:

- MindWrtParser.hxx
- MindWrtParser.cxx